=== debian/changelog ===
rustc-mozilla (1.51.0+dfsg1-1~deb11u1) bullseye; urgency=medium

  * Non-maintainer upload.
  * Backport to bullseye.
  * stage0 build.
    + Use arm-unknown-linux-gnueabi target for armel.
  * Reduce debugging symbols on i386 to avoid FTBFS due to OOM.

 -- Roberto C. Sánchez <roberto@debian.org>  Fri, 19 Nov 2021 16:58:46 -0500

rustc (1.51.0+dfsg1-1) unstable; urgency=medium

  * Upload to unstable.
  * Install the rust-llvm-dwp symlink.
  * Bump ppc64 allowed-failures to 24.

 -- Ximin Luo <infinity0@debian.org>  Sun, 19 Sep 2021 19:48:33 +0100

rustc (1.51.0+dfsg1-1~exp3) experimental; urgency=medium

  * Restore patch, not actually fixed upstream.

 -- Ximin Luo <infinity0@debian.org>  Mon, 26 Apr 2021 16:17:12 +0100

rustc (1.51.0+dfsg1-1~exp2) experimental; urgency=medium

  * Drop patch fixed upstream.
  * Fix bootstrap with self version.

 -- Ximin Luo <infinity0@debian.org>  Mon, 26 Apr 2021 12:26:43 +0100

rustc (1.51.0+dfsg1-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Enable 32-bit windows support.

 -- Ximin Luo <infinity0@debian.org>  Mon, 12 Apr 2021 11:04:36 +0100

rustc (1.50.0+dfsg1-1) unstable; urgency=medium

  * Upload to unstable.

 -- Ximin Luo <infinity0@debian.org>  Sat, 18 Sep 2021 11:45:21 +0100

rustc (1.50.0+dfsg1-1~exp4) experimental; urgency=medium

  * Fix more tests with a backported upstream PR.

 -- Ximin Luo <infinity0@debian.org>  Mon, 12 Apr 2021 01:51:22 +0100

rustc (1.50.0+dfsg1-1~exp3) experimental; urgency=medium

  * Fix cross-compile to windows using same-version stage0.

 -- Ximin Luo <infinity0@debian.org>  Sun, 11 Apr 2021 13:52:41 +0100

rustc (1.50.0+dfsg1-1~exp2) experimental; urgency=medium

  * Fix tests, fix s390x breakage.

 -- Ximin Luo <infinity0@debian.org>  Fri, 09 Apr 2021 16:54:20 +0100

rustc (1.50.0+dfsg1-1~exp1) experimental; urgency=medium

  * New upstream release.

 -- Ximin Luo <infinity0@debian.org>  Mon, 05 Apr 2021 21:30:18 +0100

rustc (1.49.0+dfsg1-2) unstable; urgency=medium

  * Backport upstream PR 85807 to fix powerpc test issues.

 -- Ximin Luo <infinity0@debian.org>  Sat, 18 Sep 2021 11:33:09 +0100

rustc (1.49.0+dfsg1-1) unstable; urgency=medium

  * Upload to unstable.

 -- Ximin Luo <infinity0@debian.org>  Sat, 28 Aug 2021 10:48:11 +0100

rustc (1.49.0+dfsg1-1~exp1) experimental; urgency=medium

  * New upstream release.

 -- Ximin Luo <infinity0@debian.org>  Mon, 05 Apr 2021 14:59:34 +0100

rustc (1.49.0~beta.4+dfsg1-1~exp1) experimental; urgency=medium

  * New upstream release.

 -- Ximin Luo <infinity0@debian.org>  Sun, 20 Dec 2020 23:26:55 +0000

rustc (1.48.0+dfsg1-2) unstable; urgency=medium

  * Enable +xgot on mips64*, see upstream #52108 for details.

 -- Ximin Luo <infinity0@debian.org>  Sun, 20 Dec 2020 18:52:10 +0000

rustc (1.48.0+dfsg1-1) unstable; urgency=medium

  * New upstream release.

 -- Ximin Luo <infinity0@debian.org>  Tue, 01 Dec 2020 19:57:48 +0000

rustc (1.48.0~beta.8+dfsg1-1~exp3) experimental; urgency=medium

  * Update u-update-version-check.patch

 -- Ximin Luo <infinity0@debian.org>  Fri, 13 Nov 2020 01:36:31 +0000

rustc (1.48.0~beta.8+dfsg1-1~exp2) experimental; urgency=medium

  * Disable copy_file_range optimisation for now, see upstream #78979.
  * Ignore some other minor tests, bugs have been filed upstream.

 -- Ximin Luo <infinity0@debian.org>  Thu, 12 Nov 2020 23:51:53 +0000

rustc (1.48.0~beta.8+dfsg1-1~exp1) experimental; urgency=medium

  * New upstream release.

 -- Ximin Luo <infinity0@debian.org>  Wed, 11 Nov 2020 12:31:18 +0000

rustc (1.47.0+dfsg1-1) unstable; urgency=medium

  * New upstream release.
  * Update to LLVM 11.
  * Ignore more tests on big-endian.

 -- Ximin Luo <infinity0@debian.org>  Sat, 07 Nov 2020 21:21:03 +0000

rustc (1.47.0~beta.2+dfsg1-1~exp1) experimental; urgency=medium

  * New upstream release.

 -- Ximin Luo <infinity0@debian.org>  Sat, 05 Sep 2020 16:11:16 +0100

rustc (1.46.0+dfsg1-1) unstable; urgency=medium

  * New upstream release.

 -- Ximin Luo <infinity0@debian.org>  Sat, 29 Aug 2020 16:54:36 +0100

rustc (1.46.0~beta.2+dfsg1-1~exp5) experimental; urgency=medium

  * Fix rust-gdb install path. (Closes: #968279)
  * Drop powerpc allowed-failures to 12. (Closes: #955774)
  * Update d-fix-mips64el-bootstrap.patch for newer LLVM.

 -- Ximin Luo <infinity0@debian.org>  Fri, 14 Aug 2020 23:45:25 +0100

rustc (1.46.0~beta.2+dfsg1-1~exp4) experimental; urgency=medium

  * Move cross-linker Depends to Recommends - for cross-compiling support
    libraries should never hard-depend on toolchains. This also allows us to
    add the usual M-A annotations for libraries.

 -- Ximin Luo <infinity0@debian.org>  Sun, 09 Aug 2020 18:16:16 +0100

rustc (1.46.0~beta.2+dfsg1-1~exp3) experimental; urgency=medium

  * Drop "-cross" suffix from libstd naming, after discussion with Helmut
    Grohne. Since libstd-rust-dev-wasm-cross is not yet in stable and only
    has 4 installed users, we do not retain a migration package. 

 -- Ximin Luo <infinity0@debian.org>  Sun, 09 Aug 2020 14:27:54 +0100

rustc (1.46.0~beta.2+dfsg1-1~exp2) experimental; urgency=medium

  * Add support for cross-compiling to windows. See README.Debian for details.
    Currently only 64-bit works, we are waiting on #540782 for 32-bit.

 -- Ximin Luo <infinity0@debian.org>  Sun, 09 Aug 2020 03:52:34 +0100

rustc (1.46.0~beta.2+dfsg1-1~exp1) experimental; urgency=medium

  * New upstream release.

 -- Ximin Luo <infinity0@debian.org>  Fri, 07 Aug 2020 00:15:46 +0100

rustc (1.45.0+dfsg1-2) unstable; urgency=medium

  * Add some more big-endian test patches.
  * Backport some patches to fix some testsuite ICEs.

 -- Ximin Luo <infinity0@debian.org>  Thu, 06 Aug 2020 21:11:39 +0100

rustc (1.45.0+dfsg1-1) unstable; urgency=medium

  * Upload to unstable.

 -- Ximin Luo <infinity0@debian.org>  Wed, 05 Aug 2020 21:41:39 +0100

rustc (1.45.0+dfsg1-1~exp1) experimental; urgency=medium

  * New upstream release.


